#include "hbclass.ch"
#include "hbcompat.ch"
#include "wvtwin.ch"

***********************************************************************************
* Hmg3 Standard MsgBox function
***********************************************************************************
FUNCTION MsgBox( cMessage, cTitle, nDefault, lGetBtNum )
 LOCAL xRetValue
 LOCAL oMsgBox := HMG_MSGBOX():New()

 WITH OBJECT oMsgBox
  :Message    := cMessage
  :Title      := cTitle
*  :BtStyle   := MB_OK           // MB_OK is default value;
  :BtDefault  := nDefault         // MB_DEFBUTTON1 is default value; you can change with other values MB_DEFBUTTON...
*  :IcoStyle  := 0               // 0 is default value; you can use MB_ICONHAND instead
*  :Modality  := MB_SYSTEMMODAL  // MB_SYSTEMMODAL is default value and preferred value;
  :GetBtNum   := lGetBtNum        // .F. (default) old Hmg3 style returned value (.T. or .F.); .T. return Button Number pressed
  xRetValue   := :Activate()      // activate message
 END WITH

 oMsgBox := NIL

RETURN xRetValue

***********************************************************************************
* Hmg3 Standard MsgInfo function
***********************************************************************************
FUNCTION MsgInfo( cMessage, cTitle, nDefault, lGetBtNum )
 LOCAL xRetValue
 LOCAL oMsgBox := HMG_MSGBOX():New()

 WITH OBJECT oMsgBox
  :Message   := cMessage
  :Title     := cTitle
  :BtStyle   := MB_OK
  :BtDefault := nDefault
  :IcoStyle  := MB_ICONINFORMATION
  :Modality  := MB_SYSTEMMODAL
  :GetBtNum  := lGetBtNum
  xRetValue  := :Activate()
 END WITH

 oMsgBox := NIL

RETURN xRetValue

***********************************************************************************
* Hmg3 Standard MsgStop function
***********************************************************************************
FUNCTION MsgStop( cMessage, cTitle, nDefault, lGetBtNum )
 LOCAL xRetValue
 LOCAL oMsgBox := HMG_MSGBOX():New()

 WITH OBJECT oMsgBox
  :Message   := cMessage
  :Title     := cTitle
  :BtStyle   := MB_OK
  :BtDefault := nDefault
  :IcoStyle  := MB_ICONSTOP
  :Modality  := MB_SYSTEMMODAL
  :GetBtNum  := lGetBtNum
  xRetValue  := :Activate()
 END WITH

 oMsgBox := NIL

RETURN xRetValue

***********************************************************************************
* Hmg3 Standard MsgExclamation function
***********************************************************************************
FUNCTION MsgExclamation( cMessage, cTitle, nDefault, lGetBtNum )
 LOCAL xRetValue
 LOCAL oMsgBox := HMG_MSGBOX():New()

 WITH OBJECT oMsgBox
  :Message   := cMessage
  :Title     := cTitle
  :BtStyle   := MB_OK
  :BtDefault := nDefault
  :IcoStyle  := MB_ICONEXCLAMATION
  :Modality  := MB_SYSTEMMODAL
  :GetBtNum  := lGetBtNum
  xRetValue  := :Activate()
 END WITH

 oMsgBox := NIL

RETURN xRetValue

***********************************************************************************
* Hmg3 Standard MsgYesNo function
***********************************************************************************
FUNCTION MsgYesNo( cMessage, cTitle, nDefault, lGetBtNum )
 LOCAL xRetValue
 LOCAL oMsgBox := HMG_MSGBOX():New()

 WITH OBJECT oMsgBox
  :Message   := cMessage
  :Title     := cTitle
  :BtStyle   := MB_YESNO
  :BtDefault := nDefault
  :IcoStyle  := MB_ICONQUESTION
  :Modality  := MB_SYSTEMMODAL
  :GetBtNum  := lGetBtNum
  xRetValue  := :Activate()
 END WITH

 oMsgBox := NIL

RETURN xRetValue

***********************************************************************************
* Hmg3 Standard MsgOkCancel function
***********************************************************************************
FUNCTION MsgOkCancel( cMessage, cTitle, nDefault, lGetBtNum )
 LOCAL xRetValue
 LOCAL oMsgBox := HMG_MSGBOX():New()

 WITH OBJECT oMsgBox
  :Message   := cMessage
  :Title     := cTitle
  :BtStyle   := MB_OKCANCEL
  :BtDefault := nDefault
  :IcoStyle  := MB_ICONQUESTION
  :Modality  := MB_SYSTEMMODAL
  :GetBtNum  := lGetBtNum
  xRetValue  := :Activate()
 END WITH

 oMsgBox := NIL

RETURN xRetValue

***********************************************************************************
* Hmg3 Standard MsgRetryCancel function
***********************************************************************************
FUNCTION MsgRetryCancel( cMessage, cTitle, nDefault, lGetBtNum )
 LOCAL xRetValue
 LOCAL oMsgBox := HMG_MSGBOX():New()

 WITH OBJECT oMsgBox
  :Message   := cMessage
  :Title     := cTitle
  :BtStyle   := MB_RETRYCANCEL
  :BtDefault := nDefault
  :IcoStyle  := MB_ICONQUESTION
  :Modality  := MB_SYSTEMMODAL
  :GetBtNum  := lGetBtNum
  xRetValue  := :Activate()
 END WITH

 oMsgBox := NIL

RETURN xRetValue

***********************************************************************************
* Hmg3 Standard MsgYesNoCancel function
***********************************************************************************
FUNCTION MsgYesNoCancel( cMessage, cTitle, nDefault, lGetBtNum )
 LOCAL xRetValue
 LOCAL oMsgBox := HMG_MSGBOX():New()

 WITH OBJECT oMsgBox
  :Message   := cMessage
  :Title     := cTitle
  :BtStyle   := MB_YESNOCANCEL
  :BtDefault := nDefault
  :IcoStyle  := MB_ICONQUESTION
  :Modality  := MB_SYSTEMMODAL
  :GetBtNum  := lGetBtNum
  xRetValue  := :Activate()
 END WITH

 oMsgBox := NIL

RETURN xRetValue

***********************************************************************************
* Hmg3 Standard MsgCancelTryContinue function
***********************************************************************************
FUNCTION MsgCancelTryContinue( cMessage, cTitle, nDefault, lGetBtNum )
 LOCAL xRetValue
 LOCAL oMsgBox := HMG_MSGBOX():New()

 WITH OBJECT oMsgBox
  :Message   := cMessage
  :Title     := cTitle
  :BtStyle   := MB_CANCELTRYCONTINUE
  :BtDefault := nDefault
  :IcoStyle  := MB_ICONQUESTION
  :Modality  := MB_SYSTEMMODAL
  :GetBtNum  := lGetBtNum
  xRetValue  := :Activate()
 END WITH

 oMsgBox := NIL

RETURN xRetValue

***********************************************************************************
* Hmg3 Standard MsgAbortRetryIgnore function
* This seem to be deprecate from MSDN API documentation; use MsgCancelTryContinue instead
***********************************************************************************
FUNCTION MsgAbortRetryIgnore( cMessage, cTitle, nDefault, lGetBtNum )
 LOCAL xRetValue
 LOCAL oMsgBox := HMG_MSGBOX():New()

 WITH OBJECT oMsgBox
  :Message   := cMessage
  :Title     := cTitle
  :BtStyle   := MB_ABORTRETRYIGNORE
  :BtDefault := nDefault
  :IcoStyle  := MB_ICONQUESTION
  :Modality  := MB_SYSTEMMODAL
  :GetBtNum  := lGetBtNum
  xRetValue  := :Activate()
 END WITH

 oMsgBox := NIL

RETURN xRetValue

*==================================================================================
* class HMG_MSGBOX
*==================================================================================
CLASS HMG_MSGBOX FROM CONTROL

* shared values

* internal data
 DATA cMessage                  INIT   ""                PROTECTED
 DATA nBtPress                  INIT   0                 PROTECTED
 DATA nBtStyle                  INIT   MB_OK             PROTECTED
 DATA nIcoStyle                 INIT   0                 PROTECTED
 DATA nModality                 INIT   MB_SYSTEMMODAL    PROTECTED
 DATA nDefButton                INIT   MB_DEFBUTTON1     PROTECTED
 DATA lGetBtNum                 INIT   .F.               PROTECTED

* methods
 METHOD New
 METHOD Activate

* properties
 METHOD BtDefault           SETGET
 METHOD BtStyle             SETGET
 METHOD IcoStyle            SETGET
 METHOD Message             SETGET
 METHOD Modality            SETGET
 METHOD GetBtNum            SETGET

ENDCLASS

*------------------------------------------------------------------------------*
* class HMG_MSGBOX methods                                                     *
*------------------------------------------------------------------------------*

*..............................................................................*
* class HMG_MSGBOX - New method
*..............................................................................*
METHOD HMG_MSGBOX:New()

RETURN Self

*..............................................................................*
* class HMG_MSGBOX - Activate method
*..............................................................................*
METHOD HMG_MSGBOX:Activate()

 LOCAL xRetValue

 xRetValue := ::nBtPress := C_MSGBOX( ::cMessage, ::cTitle, ::nModality, ::nBtStyle, ::nIcoStyle, ::nDefButton )

 IF ::lGetBtNum == .F.
  SWITCH ::nBtStyle
   CASE MB_OK
    xRetValue := IF( ::nBtPress == IDOK, .T., .F. )
   EXIT
   CASE MB_OKCANCEL
    xRetValue := IF( ::nBtPress == IDOK, .T., .F. )
   EXIT
   CASE MB_ABORTRETRYIGNORE
    xRetValue := IF( ::nBtPress == IDABORT, .T., .F. )
   EXIT
   CASE MB_YESNOCANCEL
    xRetValue := IF( ::nBtPress == IDYES, .T., .F. )
   EXIT
   CASE MB_YESNO
    xRetValue := IF( ::nBtPress == IDYES, .T., .F. )
   EXIT
   CASE MB_RETRYCANCEL
    xRetValue := IF( ::nBtPress == IDRETRY, .T., .F. )
   EXIT
   CASE MB_CANCELTRYCONTINUE
    xRetValue := IF( ::nBtPress == IDCANCEL, .T., .F. )
   EXIT
  END SWITCH
 ENDIF

RETURN xRetValue

*------------------------------------------------------------------------------*
* class HMG_MSGBOX properties                                                  *
*------------------------------------------------------------------------------*

*..............................................................................*
* class HMG_MSGBOX - BtDefault property
*..............................................................................*
METHOD HMG_MSGBOX:BtDefault( nArg1 )

 IF PCOUNT() == 0
  RETURN ::nDefButton
 ELSE
  IF HB_ISNUMERIC( nArg1 ) .AND. nArg1 >= MB_DEFBUTTON1 .AND. nArg1 <= MB_DEFBUTTON4
   ::nDefButton := nArg1
  ENDIF
 ENDIF

RETURN NIL

*..............................................................................*
* class HMG_MSGBOX - BtDefault property
*..............................................................................*
METHOD HMG_MSGBOX:BtStyle( nArg1 )

 IF PCOUNT() == 0
  RETURN ::nBtStyle
 ELSE
  IF HB_ISNUMERIC( nArg1 ) .AND. nArg1 >= MB_OK .AND. nArg1 <= MB_CANCELTRYCONTINUE
   ::nBtStyle := nArg1
  ENDIF
 ENDIF

RETURN NIL

*..............................................................................*
* class HMG_MSGBOX - IcoStyle property
*..............................................................................*
METHOD HMG_MSGBOX:IcoStyle( nArg1 )

 IF PCOUNT() == 0
  RETURN ::nIcoStyle
 ELSE
  IF HB_ISNUMERIC( nArg1 ) .AND. ( ( nArg1 >= MB_ICONHAND .AND. nArg1 <= MB_USERICON ) .OR. ( nArg1 == 0 ) )
   ::nIcoStyle := nArg1
  ENDIF
 ENDIF

RETURN NIL

*..............................................................................*
* class HMG_MSGBOX - Message property
*..............................................................................*
METHOD HMG_MSGBOX:Message( cArg1 )

 IF PCOUNT() == 0
  RETURN ::cMessage
 ELSE
  IF HB_ISCHAR( cArg1 )
   ::cMessage := cArg1
  ENDIF
 ENDIF

RETURN NIL

*..............................................................................*
* class HMG_MSGBOX - Modality property
*..............................................................................*
METHOD HMG_MSGBOX:Modality( nArg1 )

 IF PCOUNT() == 0
  RETURN ::nModality
 ELSE
  IF HB_ISNUMERIC( nArg1 ) .AND. nArg1 >= MB_APPLMODAL .AND. nArg1 <= MB_TASKMODAL
   ::nModality := nArg1
  ENDIF
 ENDIF

RETURN NIL

*..............................................................................*
* class HMG_MSGBOX - GetBtNum property
*..............................................................................*
METHOD HMG_MSGBOX:GetBtNum( lArg1 )

 IF PCOUNT() == 0
  RETURN ::lGetBtNum
 ELSE
  ::lGetBtNum := IF( HB_ISLOGICAL( lArg1 ), lArg1, ::lGetBtNum )
 ENDIF

RETURN NIL
